/**
 * Demos of different kinds of loops
 * 
 * @author Claude Sammut 
 * @version 29/7/2012
 */
public class Loops
{
    /**
     * An example of nested if statement
     */
    public void ifTest1()
    {
        int testScore = 76;
        char grade;

        if (testScore >= 90)
        {
            grade = 'A';
        }
        else
        {
            if (testScore >= 80)
            {
                grade = 'B';
            }
            else
            {
                if (testScore >= 70)
                {
                    grade = 'C';
                }
                else
                {
                    if (testScore >= 60)
                    {
                        grade = 'D';
                    }
                    else
                    {
                        grade = 'F';
                    }
                }
            }
        }

        System.out.println("Grade = " + grade);
    }

    /**
     * This is the same as above just a different format to emphasis the fact that this
     * nesting creates a list of alternatives
     */
    public void ifTest2()
    {
        int testScore = 76;
        char grade;

        if (testScore >= 90)
            grade = 'A';
        else if (testScore >= 80)
            grade = 'B';
        else if (testScore >= 70)
            grade = 'C';
        else if (testScore >= 60)
            grade = 'D';
        else
            grade = 'F';

        System.out.println("Grade = " + grade);
        System.out.println("Grade = " + grade);
    }

    public void whileLoopDemo()
    {
        // we have an amount of money in an interest bearing account: initialBalance
        // each year we make a fixed deposit to the account: annualDeposit
        // the account earns at an annual rate of interest: apr
        // how many years are required for our account to double in value: years
    
        // declare variables
        float initialBalance = 1000F;  // let's begin with $1,000 balance
        float annualDeposit = 100F;    // then deposit $100 at end of each year 
        float apr = 0.05F;             // annual interest rate is 5% 
        float currentBalance;          // running balance 
        int numberOfYears;             // count the number of years 
    
        // initialize currentBalance and numberOfYears
        currentBalance = initialBalance;  
        numberOfYears = 0;
        
        System.out.println ("Output From while Loop");  // print headings
        System.out.println ("Year    Balance");

        while (currentBalance <= 2 * initialBalance)  
        {
            currentBalance = currentBalance * (1 + apr) + annualDeposit;
            numberOfYears++;  
            System.out.println (numberOfYears + "         " + Math.round(currentBalance));
        }

        System.out.print ("In " + numberOfYears + " years ");
        System.out.println ("the balance will be " + Math.round(currentBalance));
    }

        public void doLoopDemo()
    {
        // we have an amount of money in an interest bearing account: initialBalance
        // each year we make a fixed deposit to the account: annualDeposit
        // the account earns at an annual rate of interest: apr
        // how many years are required for our account to double in value: years
    
        // declare variables
        float initialBalance = 1000F;  // let's begin with $1,000 balance
        float annualDeposit = 100F;    // then deposit $100 at end of each year 
        float apr = 0.05F;             // annual interest rate is 5% 
        float currentBalance;          // running balance 
        int numberOfYears;             // count the number of years 
    
        // initialize currentBalance and numberOfYears
        currentBalance = initialBalance;  
        numberOfYears = 0;
        
        System.out.println ("Output From while Loop");  // print headings
        System.out.println ("Year    Balance");

        do
        {
            currentBalance = currentBalance * (1 + apr) + annualDeposit;
            numberOfYears++;  
            System.out.println (numberOfYears + "         " + Math.round(currentBalance));
        } while (currentBalance <= 2 * initialBalance);

        System.out.print ("In " + numberOfYears + " years ");
        System.out.println ("the balance will be " + Math.round(currentBalance));
    }
    
    public void forLoopDemo()
    {
        // we have an amount of money in an interest bearing account: initialBalance
        // each year we make a fixed deposit to the account: annualDeposit
        // the account earns at an annual rate of interest: apr
        // how many years are required for our account to double in value: years
    
        // declare variables
        float initialBalance = 1000F;  // let's begin with $1,000 balance
        float annualDeposit = 100F;    // then deposit $100 at end of each year 
        float apr = 0.05F;             // annual interest rate is 5% 
        float currentBalance;          // running balance 
        int numberOfYears;             // count the number of years 
    
        // initialize currentBalance and numberOfYears
        currentBalance = initialBalance;
        
        System.out.println ("Output From while Loop");  // print headings
        System.out.println ("Year    Balance");

        for (numberOfYears = 0; currentBalance <= 2 * initialBalance; numberOfYears++)
        {
            currentBalance = currentBalance * (1 + apr) + annualDeposit;
            System.out.println (numberOfYears + "         " + Math.round(currentBalance));
        }

        System.out.print ("In " + numberOfYears + " years ");
        System.out.println ("the balance will be " + Math.round(currentBalance));
    }
}
